Subject: Re: performance monitor exceptions

From: Werner Almesberger <[email-masked]>
Date: Tue, 12 Feb 2002 19:33:17 +0100

[email-masked] wrote:
>  - I don't know how the perf. mon stuff works, but couldn't you
> enter a condition were the CPU is continuously sending your the
> pef monitor exception until you clear something else ?

No, in a performance monitor exception, PMXE (PM exception enable)
is cleared in MMCR0, and I need to set it explicitly to get another
exception. The only performance event source that's enabled is the
one using the timer base, so this gives me exceptions at 200 Hz,
more if I want.

>  - I encountered a problem with the TAU stuff and the 7400 where
> the CPU could actually get mixed up when getting both a normal
> interrupt and a TAU exception and scew up itself (by taking both
> exceptions and screwing up SRR0/1)

Bingo ! That seems to be the one:

http://www.mot.co.jp/SPS/html/lit/pdf/mpc7410pns_rev0.pdf

  #5:
  Description: Consecutive Performance Monitor, Decrementer,
  or Thermal Management Interrupts may become non-recoverable.

  Work-Around: Avoid enabling any combination of
  Performance Monitor, Decrementer, or Thermal Management
  Interrupts at the same time.

Hmm, working around this will be tricky ...

Thanks a lot !

- Werner

--
  _________________________________________________________________________
 / Werner Almesberger, Lausanne, CH                    [email-masked] /
/_http://icawww.epfl.ch/almesberger/_____________________________________/

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/